/*
 * Copyright 2018 by Kappich Systemberatung Aachen
 * ALL RIGHTS RESERVED.
 */

package de.bsvrz.dav.daf.main.authentication;

import java.io.BufferedReader;
import java.io.Console;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.Scanner;

/**
 * Implementierung eines automatisierten Login. Das Passwort bzw. der Token wird in einem UTF-16BE-kodierten Datenstrom im STDIN an die Applikation übertragen.
 *
 * @author Kappich Systemberatung
 * 
 * @since  3.14
 */
public class DirectInteractiveAuthentication implements UserProperties {
	public static DirectInteractiveAuthentication getInstance() {
		return new DirectInteractiveAuthentication();
	}

	private DirectInteractiveAuthentication() {
	}

	@Override
	public ClientCredentials getClientCredentials(final String userName, final String suffix) {
		@SuppressWarnings("IOResourceOpenedButNotSafelyClosed") 
		Scanner scanner = new Scanner(System.in, "UTF_16BE");
		System.err.print("\u21a0");
		System.err.flush();
		return ClientCredentials.ofString(scanner.nextLine());
	}
}
